unit FindDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFindDialogBox = class(TComponent)
  private
    { Private 錾 }
    FForm1: TForm;             // _CAO{bNXtH[
    FLabel1: TLabel;           // u : vx
    FComboBox1: TComboBox;     // ̃Xg
    FFindItems: TStrings;      // Items vpeB̎QƃtB[h(= FComboBox1.Items)
    FCheckBox1: TCheckBox;     // 啶Ə
    FCheckBox2: TCheckBox;     // G^[L[ŕXgɒǉ
    FCheckBox3: TCheckBox;     // ɕXgɒǉ
    FRadioGroup1: TRadioGroup; // 
    FButton1: TButton;         // uv{^
    FButton2: TButton;         // uLZv{^
    FButton3: TButton;         // u폜v{^
    FButton4: TButton;         // uNA[v{^
    FEOption: Boolean;         // G^[L[ŕXgɒǉ
    FFOption: Boolean;         // ɕXgɒǉ
    FOnFind: TNotifyEvent;     // OnFind CxgtB[h
    FOnChangeFindText: TNotifyEvent;  // OnChangeFindText CxgtB[h
    FOnChangeDirection: TNotifyEvent; // OnChangeDirection CxgtB[h
    FOnChangeDivision: TNotifyEvent;  // OnChangeDivision CxgtB[h
    FOnShow: TNotifyEvent;     // OnShow CxgtB[h
    FOnClose: TCloseEvent;     // OnClose CxgtB[h
    function GetDirection: Boolean;
    function GetDivision: Boolean;
    function GetFindText: String;
    function GetFindItemIndex: Integer;
    function GetPPoint: TPoint;
    function GetSize: Integer;
    function GetTitle: String;
    function GetDialogWidth: Integer;
    function GetDialogHeight: Integer;
    procedure SetFindText(const Value: String);
    procedure SetFindItemIndex(const Value: Integer);
    procedure SetDirection(const Value: Boolean);
    procedure SetDivision(const Value: Boolean);
    procedure SetEOption(const Value: Boolean);
    procedure SetFOption(const Value: Boolean);
    procedure SetPPoint(const Value: TPoint);
    procedure SetSize(const Value: Integer);
    procedure SetTitle(const Value: String);
    procedure MakeForm;
    procedure SetFontSize;
    procedure ComboAdd;
  protected
    { Protected 錾 }
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    { Cxg\bh錾 }
    procedure DoFind; dynamic;
    procedure DoChangeFindText; dynamic;
    procedure DoChangeDirection; dynamic;
    procedure DoChangeDivision; dynamic;
    procedure DoShow; dynamic;
    procedure DoClose(var Action: TCloseAction); dynamic;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Close; virtual;
    procedure Hide; virtual;
    procedure Show; virtual;
    procedure Execute; virtual;
    { vpeB錾 }
    property FindItems: TStrings read FFindItems;
    property PPoint: TPoint read GetPPoint write SetPPoint;
    property DialogWidth: Integer read GetDialogWidth;
    property DialogHeight: Integer read GetDialogHeight;
  published
    { Published 錾 }
    property Title: String read GetTitle write SetTitle;
    property FindText: String read GetFindText write SetFindText;
    property FindItemIndex: Integer read GetFindItemIndex write SetFindItemIndex;
    property Direction: Boolean read GetDirection write SetDirection default True;
    property Division: Boolean read GetDivision write SetDivision default True;
    property EOption: Boolean read FEOption write SetEOption default False;
    property FOption: Boolean read FFOption write SetFOption default False;
    property Size: Integer read GetSize write SetSize default 12;
    { Cxg錾 }
    property OnFind: TNotifyEvent read FOnFind write FOnFind;
    property OnChangeFindText: TNotifyEvent read FOnChangeFindText write FOnChangeFindText;
    property OnChangeDirection: TNotifyEvent read FOnChangeDirection write FOnChangeDirection;
    property OnChangeDivision: TNotifyEvent read FOnChangeDivision write FOnChangeDivision;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
    property OnClose: TCloseEvent read FOnClose write FOnClose;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ToolBox', [TFindDialogBox]);
end;
{ TFindDialogBox }

constructor TFindDialogBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEOption := False;         // G^[L[ŕXgɒǉ
  FFOption := False;         // ɕXgɒǉ
  MakeForm;
  FComboBox1.OnKeyDown := ComboBox1KeyDown;
  FComboBox1.OnChange := ComboBox1Change;
  FFindItems := FComboBox1.Items; // Items vpeB̎QƃtB[h
  FCheckBox1.OnClick := CheckBox1Click;
  FCheckBox2.OnClick := CheckBox2Click;
  FCheckBox3.OnClick := CheckBox3Click;
  FRadioGroup1.OnClick  := RadioGroup1Click;
  FButton1.OnClick := Button1Click;
  FButton2.OnClick := Button2Click;
  FButton3.OnClick := Button3Click;
  FButton4.OnClick := Button4Click;
  FForm1.OnShow := FormShow;
  FForm1.OnClose := FormClose;
end;

destructor TFindDialogBox.Destroy;
begin
  inherited Destroy;
end;

procedure TFindDialogBox.Button1Click(Sender: TObject);
begin
  if FFOption then
    ComboAdd;
  DoFind;
end;

procedure TFindDialogBox.Button2Click(Sender: TObject);
begin
  FForm1.Close;
end;

procedure TFindDialogBox.Button3Click(Sender: TObject);
var
  i: Integer;
begin
  i := FComboBox1.ItemIndex;
  if i = -1 then
    i := FComboBox1.Items.IndexOf(FComboBox1.Text);
  if i <> -1 then
  begin
    FComboBox1.Items.Delete(i);
    if i = FComboBox1.Items.Count then
      Dec(i);
  end;
  FComboBox1.ItemIndex := i;
  if i = -1 then
    FComboBox1.Text := '';
end;

procedure TFindDialogBox.Button4Click(Sender: TObject);
begin
  FComboBox1.Items.Clear;
  FComboBox1.ItemIndex := -1;
  FComboBox1.Text := '';
end;

procedure TFindDialogBox.CheckBox1Click(Sender: TObject);
begin
  DoChangeDivision;
end;

procedure TFindDialogBox.CheckBox2Click(Sender: TObject);
begin
  FEOption := FCheckBox2.Checked;
end;

procedure TFindDialogBox.CheckBox3Click(Sender: TObject);
begin
  FFOption := FCheckBox3.Checked;
end;

procedure TFindDialogBox.Close;
begin
  FForm1.Close;
end;

procedure TFindDialogBox.ComboAdd;
var
  i: Integer;
begin
  i := FComboBox1.Items.IndexOf(FComboBox1.Text);
  if i = -1 then
    FComboBox1.Items.Insert(0, FComboBox1.Text)
  else if i > 0 then
    FComboBox1.Items.Move(i, 0);
  FComboBox1.ItemIndex := 0;
end;

procedure TFindDialogBox.ComboBox1Change(Sender: TObject);
begin
  DoChangeFindText;
end;

procedure TFindDialogBox.ComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = $0D) and (FComboBox1.Text <> '') then
  begin
    if FEOption then
      ComboAdd;
    DoFind;
  end;
end;

procedure TFindDialogBox.DoChangeDirection; // Cxg\bh
begin
  if Assigned(FOnChangeDirection) then
    FOnChangeDirection(Self); // CxgnȟĂяo
end;

procedure TFindDialogBox.DoChangeDivision; // Cxg\bh
begin
  if Assigned(FOnChangeDivision) then
    FOnChangeDivision(Self); // CxgnȟĂяo
end;

procedure TFindDialogBox.DoChangeFindText;
begin
  if Assigned(FOnChangeFindText) then
    FOnChangeFindText(Self); // CxgnȟĂяo
end;

procedure TFindDialogBox.DoClose(var Action: TCloseAction); // Cxg\bh
begin
  if Assigned(FOnClose) then
    FOnClose(Self, Action); // CxgnȟĂяo
end;

procedure TFindDialogBox.DoFind; // Cxg\bh
begin
  if Assigned(FOnFind) then
    FOnFind(Self); // CxgnȟĂяo
end;

procedure TFindDialogBox.DoShow; // Cxg\bh
begin
  if Assigned(FOnShow) then
    FOnShow(Self); // CxgnȟĂяo
end;

procedure TFindDialogBox.Execute;
begin
  FForm1.Show;
end;

procedure TFindDialogBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DoClose(Action);
end;

procedure TFindDialogBox.FormShow(Sender: TObject);
begin
  DoShow;
  FComboBox1.SetFocus;
end;

function TFindDialogBox.GetDirection: Boolean;
begin
  if FRadioGroup1.ItemIndex = 0 then
    Result := False
  else // FRadioGroup1.ItemIndex = 1
    Result := True;
end;

function TFindDialogBox.GetDivision: Boolean;
begin
  Result := FCheckBox1.Checked;
end;

function TFindDialogBox.GetDialogHeight: Integer;
begin
  Result := FForm1.Height;
end;

function TFindDialogBox.GetDialogWidth: Integer;
begin
  Result := FForm1.Width;
end;

function TFindDialogBox.GetFindItemIndex: Integer;
begin
  Result := FComboBox1.ItemIndex;
end;

function TFindDialogBox.GetFindText: String;
begin
  Result := FComboBox1.Text;
end;

function TFindDialogBox.GetPPoint: TPoint;
begin
  Result := Point(FForm1.Left, FForm1.Top);
end;

function TFindDialogBox.GetSize: Integer;
begin // tH[̃TCYƂ̂́Aۂ́A-Form1.Font.Height łB
  Result := Abs(FForm1.Font.Height);
end;

function TFindDialogBox.GetTitle: String;
begin
  Result := FForm1.Caption;
end;

procedure TFindDialogBox.Hide;
begin
  FForm1.Hide;
end;

procedure TFindDialogBox.MakeForm;
var
  DialogUnits: TPoint;
begin
  FForm1 := TForm.Create(Application);
  with FForm1 do
  begin
    Canvas.Font := Font;
    DialogUnits := Point(Abs(Font.Height), Abs(Font.Height));
    BorderStyle := bsDialog;
    FormStyle := fsStayOnTop;
    ClientWidth := MulDiv(392, DialogUnits.X, 12);
    ClientHeight := MulDiv(140, DialogUnits.Y, 12);
    Left := Screen.Width div 2;
    Top := Screen.Height div 2;
    Caption := '';
    FLabel1 := TLabel.Create(FForm1);
    with FLabel1 do
    begin
      Parent := FForm1;
      Caption := ' : ';
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12),
                MulDiv(70, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12));
    end;
    FComboBox1 := TComboBox.Create(FForm1);
    with FComboBox1 do
    begin
      Parent := FForm1;
      SetBounds(MulDiv(80, DialogUnits.X, 12), MulDiv(8, DialogUnits.Y, 12),
                MulDiv(305, DialogUnits.X, 12), MulDiv(20, DialogUnits.Y, 12));
    end;
    FCheckBox1 := TCheckBox.Create(FForm1);
    with FCheckBox1 do
    begin
      Parent := FForm1;
      Caption := '啶Ə';
      Checked := True;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(36, DialogUnits.Y, 12),
                MulDiv(145, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));
    end;
    FCheckBox2 := TCheckBox.Create(FForm1);
    with FCheckBox2 do
    begin
      Parent := FForm1;
      Caption := 'G^[L[ŕXgɒǉ';
      Checked := False;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(58, DialogUnits.Y, 12),
                MulDiv(217, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));
    end;
    FCheckBox3 := TCheckBox.Create(FForm1);
    with FCheckBox3 do
    begin
      Parent := FForm1;
      Caption := 'ɕXgɒǉ';
      Checked := False;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(80, DialogUnits.Y, 12),
                MulDiv(209, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));
    end;
    FRadioGroup1 := TRadioGroup.Create(FForm1);
    with FRadioGroup1 do
    begin
      Parent := FForm1;
      Caption := '';
      FRadioGroup1.Items.Add('');
      FRadioGroup1.Items.Add('');
      FRadioGroup1.ItemIndex := 1;
      SetBounds(MulDiv(228, DialogUnits.X, 12), MulDiv(40, DialogUnits.Y, 12),
                MulDiv(65, DialogUnits.X, 12), MulDiv(49, DialogUnits.Y, 12));
    end;
    FButton1 := TButton.Create(FForm1);
    with FButton1 do
    begin
      Parent := FForm1;
      Caption := '';
      ModalResult := mrNone;
      SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(40, DialogUnits.Y, 12),
                MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton2 := TButton.Create(FForm1);
    with FButton2 do
    begin
      Parent := FForm1;
      Caption := 'LZ';
      ModalResult := mrNone;
      SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(72, DialogUnits.Y, 12),
                MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton3 := TButton.Create(FForm1);
    with FButton3 do
    begin
      Parent := FForm1;
      Caption := '폜';
      ModalResult := mrNone;
      SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(108, DialogUnits.Y, 12),
                MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
    FButton4 := TButton.Create(FForm1);
    with FButton4 do
    begin
      Parent := FForm1;
      Caption := 'NA[';
      ModalResult := mrNone;
      SetBounds(MulDiv(96, DialogUnits.X, 12), MulDiv(108, DialogUnits.Y, 12),
                MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
    end;
  end;
end;

procedure TFindDialogBox.RadioGroup1Click(Sender: TObject);
begin
  DoChangeDirection;
end;

procedure TFindDialogBox.SetDirection(const Value: Boolean);
begin
  if Value = False then
    FRadioGroup1.ItemIndex := 0
  else // Value = True
    FRadioGroup1.ItemIndex := 1;
  DoChangeDirection;
end;

procedure TFindDialogBox.SetDivision(const Value: Boolean);
begin
  FCheckBox1.Checked := Value;
  DoChangeDivision;
end;

procedure TFindDialogBox.SetEOption(const Value: Boolean);
begin
  FEOption := Value;
  FCheckBox2.Checked := Value;
end;

procedure TFindDialogBox.SetFindItemIndex(const Value: Integer);
begin
  FComboBox1.ItemIndex := Value;
end;

procedure TFindDialogBox.SetFindText(const Value: String);
begin
  FComboBox1.Text := Value;
end;

procedure TFindDialogBox.SetFontSize;
var
  DialogUnits: TPoint;
begin
  with FForm1 do
  begin
    Canvas.Font := Font;
    DialogUnits := Point(Abs(Font.Height), Abs(Font.Height));
    ClientWidth := MulDiv(392, DialogUnits.X, 12);
    ClientHeight := MulDiv(140, DialogUnits.Y, 12);
  end;

  FLabel1.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12),
                    MulDiv(70, DialogUnits.X, 12), MulDiv(12, DialogUnits.Y, 12));

  FComboBox1.SetBounds(MulDiv(80, DialogUnits.X, 12), MulDiv(8, DialogUnits.Y, 12),
                       MulDiv(305, DialogUnits.X, 12), MulDiv(20, DialogUnits.Y, 12));

  FCheckBox1.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(36, DialogUnits.Y, 12),
                       MulDiv(145, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));

  FCheckBox2.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(58, DialogUnits.Y, 12),
                       MulDiv(217, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));

  FCheckBox3.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(80, DialogUnits.Y, 12),
                       MulDiv(209, DialogUnits.X, 12), MulDiv(17, DialogUnits.Y, 12));

  FRadioGroup1.SetBounds(MulDiv(228, DialogUnits.X, 12), MulDiv(40, DialogUnits.Y, 12),
                         MulDiv(65, DialogUnits.X, 12), MulDiv(49, DialogUnits.Y, 12));

  FButton1.SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(40, DialogUnits.Y, 12),
                     MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton2.SetBounds(MulDiv(309, DialogUnits.X, 12), MulDiv(72, DialogUnits.Y, 12),
                     MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton3.SetBounds(MulDiv(8, DialogUnits.X, 12), MulDiv(108, DialogUnits.Y, 12),
                     MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));

  FButton4.SetBounds(MulDiv(96, DialogUnits.X, 12), MulDiv(108, DialogUnits.Y, 12),
                     MulDiv(75, DialogUnits.X, 12), MulDiv(21, DialogUnits.Y, 12));
end;

procedure TFindDialogBox.SetFOption(const Value: Boolean);
begin
  FFOption := Value;
  FCheckBox3.Checked := Value;
end;

procedure TFindDialogBox.SetPPoint(const Value: TPoint);
begin
  FForm1.Left := Value.X;
  FForm1.Top := Value.Y;
end;

procedure TFindDialogBox.SetSize(const Value: Integer);
begin
  if Value in [10..20] then
  begin
    FForm1.Font.Height := -Value;
    SetFontSize;
  end;
end;

procedure TFindDialogBox.SetTitle(const Value: String);
begin
  FForm1.Caption := Value;
end;

procedure TFindDialogBox.Show;
begin
  FForm1.Show;
end;

end.

