unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FindDialog, DataList, ToolBox, ComCtrls,
  ReplaceDialog;

const
  { ̋؂q }
  Separator: set of Byte = [$09, $0A, $0D, $20..$2F, $3A..$3F, $5B..$5E, $7B..$7D];

type
  TFrameForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Memo1: TMemo;
    FindDialogBox1: TFindDialogBox;
    Button4: TButton;
    Button3: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    UpDown2: TUpDown;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    ReplaceDialogBox1: TReplaceDialogBox;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FindDialogBox1Show(Sender: TObject);
    procedure FindDialogBox1Find(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FindDialogBox1ChangeDivision(Sender: TObject);
    procedure FindDialogBox1ChangeFindText(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ReplaceDialogBox1ChangeDivision(Sender: TObject);
    procedure ReplaceDialogBox1ChangeFindText(Sender: TObject);
    procedure ReplaceDialogBox1Show(Sender: TObject);
    procedure ReplaceDialogBox1Find(Sender: TObject);
    procedure ReplaceDialogBox1ReplaceFind(Sender: TObject);
    procedure ReplaceDialogBox1ReplaceAll(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FindDialogBox1ChangeDirection(Sender: TObject);
    procedure ReplaceDialogBox1ChangeDirection(Sender: TObject);
  private
    { Private 錾 }
    procedure GetFindStr;
    procedure DispInfor;
    procedure Search(Down: Boolean; MatchCase: Boolean);
    function ReplaceOne(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Boolean;
    function ReplaceAll(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Integer;
  public
    { Public 錾 }
    FileName: String;
    FindStr: String;
    FoundPos: Integer;
    OldDown: Boolean;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

{ ReplaceOne ́Ã݂ZʒuҏWf[^ɂ镔 FindText }
{ ̐擪wĂ΁A̕̕ҏWf[^ ReplaceText Œu }
{ ֐łBuꍇ́ATrue łȂꍇ́AFalse Ԃ܂B}
{ MatchCase  False ̏ꍇ́AҏWf[^ FindText ŔpAt@xbg }
{ ̑啶Əʂ܂B}

function TFrameForm.ReplaceOne(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Boolean;
var
  i: Integer;
begin
  Result := False;
  i := Memo1.SelStart;
  Memo1.Perform(EM_SCROLLCARET, 0, 0);

  if PosI(FindText, Memo1.Text, i, MatchCase) - 1 <> i then
    Exit;

  Memo1.SelLength := 0; // I͈͂NA[Ă
  Memo1.SelLength := Length(FindText);
  Memo1.SelText := ReplaceText;
  Result := True;
end;

{ ReplaceAll ́AҏWf[^ɂ镔 FindText S ReplaceText  }
{ uAuԂ֐łBMatchCase  False ̏ꍇ́AҏWf[^ }
{  FindText ŔpAt@xbg̑啶Əʂ܂B}

function TFrameForm.ReplaceAll(const FindText: String; const ReplaceText: String; MatchCase: Boolean): Integer;
var
  i: Integer;
  S: String;
begin
  i := Memo1.SelStart; // ݂̃Zʒu
  S := Memo1.Text;

  Result := ReplaceString(S, FindText, ReplaceText, MatchCase);

  if Result > 0 then
    Memo1.Text := S;

  if i > Length(Memo1.Text) then
    i := Length(Memo1.Text);
  Memo1.SelStart := i; // ZʒuƂɖ߂B
  Memo1.Perform(EM_SCROLLCARET, 0, 0);
end;

procedure TFrameForm.GetFindStr;
var
  i: Integer;
  Len: Integer;
  S: String;
begin
  if Memo1.SelLength <> 0 then
    S := Copy(Memo1.SelText, 1, 64) // ő 64 
  else
    S := Copy(Memo1.Text, Memo1.SelStart + 1, 64); // ő 64 
  Len := Length(S);

  i := 1;
  while i <= Len do
  begin
    if (Ord(S[i]) in Separator) then
      Break;
    Inc(i);
  end;
  Dec(i);

  if ByteType(S, i) = mbLeadByte then
    Dec(i);

  if i > 0 then
    FindStr := Copy(S, 1, i);

  Edit1.Text := FindStr;
end;

procedure TFrameForm.DispInfor;
var
  i, X, Y: Integer;
begin
  i := Memo1.SelStart;
  Y := Memo1.Perform(EM_LINEFROMCHAR, -1, 0) + 1;
  X := i - Memo1.Perform(EM_LINEINDEX, Y - 1, 0) + 1;
  if FoundPos = -1 then
    Caption := 'TFindDialogBox & TReplaceDialogBox ̃eXg --- ܂łB'
  else
    Caption := 'TFindDialogBox & TReplaceDialogBox ̃eXg --- ' +
               IntToStr(Y) + ' s ' + IntToStr(X) + ' ڂɌ܂B';
end;

procedure TFrameForm.Search(Down: Boolean; MatchCase: Boolean);
var
  FindPos: Integer;
begin
  Caption := 'TFindDialogBox & TReplaceDialogBox ̃eXg';
  
  if FindStr = '' then
    Exit;

  { ݂̃J[\ʒu猟Jn܂B}
  { IĂꍇ́AꕶJnʒuړ܂B}
  if (FoundPos = -1) and (OldDown = Down) then
    Exit;
  OldDown := Down;
  FindPos := Memo1.SelStart;
  if Down then
  begin
    if Memo1.SelLength <> 0 then
      Inc(FindPos);
    while True do
    begin
      FoundPos := PosI(FindStr, Memo1.Text, FindPos + 1, MatchCase) - 1;
      if (FoundPos = -1)
       or (ByteTypeX(Memo1.Text, FoundPos + 1) <> mbTrailByte) then
        Break;
      FindPos := FoundPos + 1;
    end;
  end
  else
  begin
    if Memo1.SelLength <> 0 then
      Dec(FindPos);
    if FindPos > Length(Memo1.Text) - Length(FindStr) then
      FindPos := Length(Memo1.Text) - Length(FindStr);
    while True do
    begin
      FoundPos := RPosI(FindStr, Memo1.Text, FindPos + 1, MatchCase) - 1;
      if (FoundPos = -1)
       or (ByteTypeX(Memo1.Text, FoundPos + 1) <> mbTrailByte) then
        Break;
      FindPos := FoundPos - 1;
    end;
  end;
  if FoundPos <> -1 then
  begin
    Memo1.SelStart := FoundPos;
    Memo1.SelLength := Length(FindStr);
    Memo1.Perform(EM_SCROLLCARET,0, 0);
  end
  else
    Memo1.SelLength := 0;

  DispInfor;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  FindStr := Edit1.Text;
  FileName := ExtractFilePath(Application.ExeName) + 'Readme.txt';
  Memo1.Lines.LoadFromFile(FileName);
  FileName := ExtractFilePath(Application.ExeName) + 'Find.txt';
  FindDialogBox1.FindItems.LoadFromFile(FileName);
  ReplaceDialogBox1.FindItems.LoadFromFile(FileName);
  ReplaceDialogBox1.ReplaceItems.LoadFromFile(FileName);
  FoundPos := -1;
  OldDown := False;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  FindDialogBox1.Size := UpDown2.Position;
  FindDialogBox1.Execute;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  FindDialogBox1.FindItems.SaveToFile(FileName);
end;

procedure TFrameForm.FindDialogBox1Show(Sender: TObject);
begin
  ReplaceDialogBox1.Close;
  GetFindStr;
  FindDialogBox1.FindText := FindStr;
  FindDialogBox1.PPoint := Point(Screen.Width div 2, Screen.Height div 2);
end;

procedure TFrameForm.FindDialogBox1Find(Sender: TObject);
begin
  Search(FindDialogBox1.Direction, FindDialogBox1.Division);
end;

procedure TFrameForm.Button4Click(Sender: TObject);
begin
  Search(True, FindDialogBox1.Division);
end;

procedure TFrameForm.Button3Click(Sender: TObject);
begin
  Search(False, FindDialogBox1.Division);
end;

procedure TFrameForm.FindDialogBox1ChangeDivision(Sender: TObject);
begin
  FoundPos := Memo1.SelStart;
  Memo1.SelLength := 0;
end;

procedure TFrameForm.FindDialogBox1ChangeFindText(Sender: TObject);
begin
  FindStr := FindDialogBox1.FindText;
  Edit1.Text := FindStr;
end;

procedure TFrameForm.Edit1Change(Sender: TObject);
begin
  FindStr := Edit1.Text;
end;

procedure TFrameForm.ReplaceDialogBox1ChangeDivision(Sender: TObject);
begin
  FoundPos := Memo1.SelStart;
  Memo1.SelLength := 0;
end;

procedure TFrameForm.ReplaceDialogBox1ChangeFindText(Sender: TObject);
begin
  FindStr := ReplaceDialogBox1.FindText;
  Edit1.Text := FindStr;
end;

procedure TFrameForm.ReplaceDialogBox1Show(Sender: TObject);
begin
  FindDialogBox1.Close;
  GetFindStr;
  ReplaceDialogBox1.FindText := FindStr;
  ReplaceDialogBox1.ReplaceText := FindStr;
  ReplaceDialogBox1.PPoint := Point(Screen.Width div 2, Screen.Height div 2);
end;

procedure TFrameForm.ReplaceDialogBox1Find(Sender: TObject);
begin
  Search(ReplaceDialogBox1.Direction, ReplaceDialogBox1.Division);
end;

procedure TFrameForm.ReplaceDialogBox1ReplaceFind(Sender: TObject);
begin
  ReplaceOne(ReplaceDialogBox1.FindText,
             ReplaceDialogBox1.ReplaceText,
             ReplaceDialogBox1.Division);
  if ReplaceDialogBox1.Direction = False then
    Memo1.SelStart := Memo1.SelStart - Length(ReplaceDialogBox1.ReplaceText);
  Search(ReplaceDialogBox1.Direction, ReplaceDialogBox1.Division);
end;

procedure TFrameForm.ReplaceDialogBox1ReplaceAll(Sender: TObject);
var
  Count: Integer;
begin
  Count := ReplaceAll(ReplaceDialogBox1.FindText,
                      ReplaceDialogBox1.ReplaceText,
                      ReplaceDialogBox1.Division);

  Caption := 'TFindDialogBox & TReplaceDialogBox ̃eXg --- ' +
               IntToStr(Count) + ' u܂B';
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  ReplaceDialogBox1.Size := UpDown2.Position;
  ReplaceDialogBox1.Execute;
end;

procedure TFrameForm.FindDialogBox1ChangeDirection(Sender: TObject);
begin
  FoundPos := Memo1.SelStart;
  Memo1.SelLength := 0;
end;

procedure TFrameForm.ReplaceDialogBox1ChangeDirection(Sender: TObject);
begin
  FoundPos := Memo1.SelStart;
  Memo1.SelLength := 0;
end;

end.
