unit ToolBox;

interface

uses
  Windows, Classes, Controls, ComCtrls, SysUtils, Graphics, ShellAPI, Registry;

const
  { TSearchRecs }
  stReverse   =  1; // t\[g
  stName      =  2; // t@CŃ\[g
  stSize      =  4; // t@CTCYŃ\[g
  stTime      =  8; // ^CX^vŃ\[g
  stDirectory = 16; // fBNgOɋl߂B
  stSomeSort  = 14; // \[gLǂ肷ׂ̒萔

  { oCif[^ }
  BinaryData: set of Byte = [$00..$08, $0B, $0C, $0E..$1F];

  { f[^ }
  Kanji1Data: set of Byte = [$81..$9F, $E0..$EB]; // 1oCg
  Kanji2Data: set of Byte = [$40..$7E, $80..$FC]; // 2oCg

  noChar = $0100; // f[^łȂl

type
  { TSearchRecs NX }
  TSearchRecs = class(TList)
  private
    FPath: String;
    FFullPath: String;
    FAttr: Integer;
    FSortType: Integer;
    FInRecycle: Boolean;
    procedure SetPath(const Value: String);
    procedure SetAttr(const Value: Integer);
    procedure SetSortType(const Value: Integer);
    function GetRec(Index: Integer): TSearchRec;
    procedure PutRec(Index: Integer; const Rec: TSearchRec);
    function CheckInRecycle: Boolean;
    procedure ReverseRec;
    procedure ForwardDirectory;
  protected
    procedure GetFiles; virtual;
  public
    constructor Create;
    destructor Destroy; override;
    function Add(const Rec: TSearchRec): Integer;
    procedure Clear; override;
    procedure Delete(Index: Integer);
    function IndexOf(const FileName: TFileName): Integer;
    procedure Insert(Index: Integer; const Rec: TSearchRec);
    procedure SortRec;
    procedure Refresh;
    property Path: String read FPath write SetPath;
    property FullPath: String read FFullPath write FFullPath;
    property Attr: Integer read FAttr write SetAttr default faAnyFile;
    property SortType: Integer read FSortType write SetSortType default (stName or stDirectory);
    property Recs[Index: Integer]: TSearchRec read GetRec write PutRec; default;
    property InRecycle: Boolean read FInRecycle;
  end;

type
  { TExtensionRecs }
  TidType = (idExtension, idCommand, idDefaultIcon, idExtensionKey,
             idExtensionName, idContentType, idPerceivedType);

type
  { TExtensionRecs }
  PExtensionRec = ^TExtensionRec;
  { gq }
  TExtensionRec = record
    Extension: String; // gq
    Command: String; // gq֘ÃR}h
    DefaultIcon: String; // gq֘ÃACȐݐ
    ExtensionKey: String; // gqLqĂ郌WXgL[
    ExtensionName: String; // gqt@C̈ʌď
    ContentType: String; // Web̃Rec̎
    PerceivedType: String; // gqO[v
  end;

type
  { TExtensionRecs NX }
  TExtensionRecs = class(TList)
  private
    FIcon: TIcon; // ۂ̃ACR
    FPerceivedSystem: Boolean; // gqO[vgVXeȂ True
    FSortType: TidType; // \[g
    FSorted: Boolean;
    procedure GetExtensions;
    procedure SetSorted(Value: Boolean);
    procedure SetSortType(Value: TidType);
  protected
    function GetIcon(Index: Integer): TIcon; virtual;
    function GetIconName(Index: Integer): String; virtual;
    function GetKeyCount: Integer; virtual;
    function GetRec(Index: Integer): TExtensionRec; virtual;
    procedure PutIconName(Index: Integer; const Value: String); virtual;
    procedure PutRec(Index: Integer; const Rec: TExtensionRec); virtual;
  public
    constructor Create;
    destructor Destroy; override;
    function Add(const Rec: TExtensionRec): Integer;
    procedure Clear; override;
    procedure Delete(Index: Integer);
    procedure Exchange(Index1, Index2: Integer);
    function Find(const S: String; idType: TidType; var Index: Integer): Boolean; virtual;
    function IndexOf(const S: String; idType: TidType): Integer;
    procedure Insert(Index: Integer; const Rec: TExtensionRec);
    procedure Move(CurIndex, NewIndex: Integer);
    function Remove(const Extension: String): Integer;
    procedure Refresh;
    function RSearch(Index: Integer; const S: String; idType: TidType): Integer;
    function Search(Index: Integer; const S: String; idType: TidType): Integer;
    procedure SortRec;
    property Recs[Index: Integer]: TExtensionRec read GetRec write PutRec; default;
    property IconNames[Index: Integer]: String read GetIconName write PutIconName;
    property Icons[Index: Integer]: TIcon read GetIcon;
    property PerceivedSystem: Boolean read FPerceivedSystem;
    property KeyCount: Integer read GetKeyCount; // gqȂR[h̐
    property SortType: TidType read FSortType write SetSortType default idExtension;
    property Sorted: Boolean read FSorted write SetSorted default False;
  end;

{ t@CEfBNg֌W̊֐ }
function ExpandFileDir(const Path: String): String;
function DexpandFileDir(const Path: String): String;
function IsDir(Path: String): Boolean;
function IsFile(Path: String): Boolean;
function HasSubDir(Path: String): Boolean;
function DefaultDrive: String;
function DefaultDir: String;
function CurrentDrive: String;
function CurrentDir: String;

{ ACR֌W̊֐E葱 }
procedure LoadSystemIcon(var Icons: TImageList; var IconNames: TStringList);
function SearchImageIndex(Recs: TSearchRecs; i: Integer;
                          IconNames: TStringList): Integer;
function GetImageIndex(Recs: TSearchRecs; i: Integer;
                       var Icons: TImageList;
                       var IconNames: TStringList): Integer;
procedure SweepIcons(var Icons: TImageList; var IconNames: TStringList);
function StrToIcon(IconName: String): HIcon;

{ 񏈗֐ --- String x[X }
function IntToCStr(Value: Longint): String;
function SearchString(SubStr: String; Strs: TStringList): Integer;
function TakeOff(SubStr: String; S: String): String;
function TakeAway(SubStr: String; S: String): String;
function BMPos(SubStr: String; S: String; MatchCase: Boolean): Integer;
function RBMPos(SubStr: String; S: String; MatchCase: Boolean): Integer;
function PosI(SubStr: String; S: String; Index: Integer; MatchCase: Boolean): Integer;
function PosIn(SubStr: String; S: String; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
function RPosI(SubStr: String; S: String; Index: Integer; MatchCase: Boolean): Integer;
function RPosIn(SubStr: String; S: String; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
function ReplaceString(var S: String; FindText: String; ReplaceText: String; MatchCase: Boolean): Integer;

{ 񏈗֐ --- PChar x[X }
function UpCaseX(P: PChar; Index: Integer): Char;
procedure UpperCaseX(P: PChar; Len: Integer);
function BMPosX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; MatchCase: Boolean): Integer;
function RBMPosX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; MatchCase: Boolean): Integer;
function PosIX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index: Integer; MatchCase: Boolean): Integer;
function PosInX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
function RPosIX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index: Integer; MatchCase: Boolean): Integer;
function RPosInX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
function ReplaceDataX(var P: PChar; var Len: Integer; FindData: PChar; FindLen: Integer; ReplaceData: PChar; ReplaceLen: Integer; MatchCase: Boolean): Integer;

implementation

{ pX̍Ō '\' t֐ }
{ pX '' (󕶎)̏ꍇ́A'\' Ԃ܂B}
function ExpandFileDir(const Path: String): String;
begin
  Result := Path;
  if Result = '' then
    Result := '\'
  else if Result[Length(Result)] <> '\' then
    Result := Result + '\';
end;

{ pX̍Ō '\' 菜֐ }
{ pX '' (󕶎)̏ꍇ́A'' (󕶎)Ԃ܂B}
{ pX '\' ̏ꍇɂA'' (󕶎)Ԃ܂B}
function DexpandFileDir(const Path: String): String;
begin
  Result := Path;
  if (Result <> '') and (Result[Length(Result)] = '\') then
    SetLength(Result, Length(Result) - 1);
end;

{ pXfBNgǂׂ֐ }
{ [gfBNghCufBNgƌȂ܂B}
{ pX '' (󕶎)̏ꍇ́AG[ƌȂ False Ԃ܂B}
function IsDir(Path: String): Boolean;
var
  i: Integer;
  OldMode: Integer;
  R: TSearchRec;
begin
  Result := False;
  if Path = '' then // G[
    Exit
  else if Path = '\' then // [gfBNg
  begin
    Result := True;
    Exit;
  end;
  Path := DexpandFileDir(Path); //  '\' ΂菜
  if (Length(Path) = 2) and (Path[2] = ':') then
  begin
    OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
    i := Integer(GetDriveType(PChar(Path + '\')));
    SetErrorMode(OldMode);
    if i > 1 then // [gfBNghCufBNgƌȂB
      Result := True;
  end
  else
  begin
    i := FindFirst(Path, faAnyFile, R);
    if (i = 0) and ((R.Attr and faDirectory) > 0) then
      Result := True;
    FindClose(R);
  end;
end;

{ pXAʏt@Cł邩ǂׂ֐ }
{ pX '' (󕶎)̏ꍇ́AG[ƌȂ False Ԃ܂B}
function IsFile(Path: String): Boolean;
var
  i: Integer;
  R: TSearchRec;
begin
  Result := False;
  if Path = '' then
    Exit;
  i := FindFirst(Path, faAnyFile, R);
  if (i = 0) and ((R.Attr and faDirectory) = 0)
   and ((R.Attr and faVolumeID) = 0)  then
    Result := True;
  FindClose(R);
end;

{ pXATufBNgǂׂ֐ }
{ pX '' (󕶎)̏ꍇ́AG[ƌȂ False Ԃ܂B}
function HasSubDir(Path: String): Boolean;
var
  i: Integer;
  R: TSearchRec;
begin
  Result := False;
  if Path = '' then
    Exit;
  i := FindFirst(ExpandFileDir(Path) + '*.*', faAnyFile, R);
  try
    while i = 0 do
    begin
      if ((R.Attr and faDirectory) > 0) and
       (R.Name <> '.') and (R.Name <> '..') then
      begin
        Result := True;
        Break;
      end;
      i := FindNext(R);
    end;
  finally
    FindClose(R);
  end;
end;

{ VXẽfBtHghCuAȂ킿 Windows ̋NhCu }
{ Ԃ֐ }
function DefaultDrive: String;
begin
  SetLength(Result, MAX_PATH);
  GetWindowsDirectory(PChar(Result), MAX_PATH);
  SetLength(Result, 2);
end;

{ VXẽfBtHgfBNgAȂ킿 Windows CXg[ }
{ ĂfBNgԂ֐ }
function DefaultDir: String;
var
  n: Integer;
begin
  SetLength(Result, MAX_PATH);
  n := GetWindowsDirectory(PChar(Result), MAX_PATH);
  SetLength(Result, n);
end;

{ JghCuԂ֐ }
function CurrentDrive: String;
begin
  Result := Copy(GetCurrentDir, 1, 2);
end;

{ JgfBNgԂ֐ }
function CurrentDir: String;
begin
  Result := GetCurrentDir;
end;

{ Windows ̃VXeACR擪18 Icons Ƀ[hA}
{ eACR IconNames Ɋi[葱 }
procedure LoadSystemIcon(var Icons: TImageList; var IconNames: TStringList);
var
  i: Integer;
  SysIcon: TIcon;
  ShellIconDLL: String;
begin
  if Assigned(Icons) then // Icons  Nil łȂΊeACRݒ
  begin
    ShellIconDLL := 'SHELL32.DLL'; // VXeACRi[Ăt@C
    SysIcon := TIcon.Create;
    try
      Icons.Clear;
      for i := 0 to 17 do // ACR18[h
      begin
        SysIcon.Handle := ExtractIcon(HInstance, PChar(ShellIconDLL), i);
        Icons.AddIcon(SysIcon);
        SysIcon.ReleaseHandle;
      end;
    finally
      SysIcon.Free;
    end;
  end;

  if Assigned(IconNames) then // IconNames  Nil łȂΊeACRݒ
  begin
    IconNames.Clear;
    IconNames.Add('̧ ');                  // Image Index = 0
    IconNames.Add('ţ ');            // Image Index = 1
    IconNames.Add('۸̧ .com .exe '); // Image Index = 2
    IconNames.Add('̫ ');                 // Image Index = 3
    IconNames.Add('̫ ');            // Image Index = 4
    IconNames.Add('5  ۯ߰ި ');     // Image Index = 5
    IconNames.Add('35  ۯ߰ި ');   // Image Index = 6
    IconNames.Add('Ѱި ');         // Image Index = 7
    IconNames.Add('Œި ');             // Image Index = 8
    IconNames.Add('ȯܰײ ');          // Image Index = 9
    IconNames.Add('sײ ');          // Image Index = 10
    IconNames.Add('CD-ROM ');                // Image Index = 11
    IconNames.Add('RAM ި ');             // Image Index = 12
    IconNames.Add('ȯܰS ');            // Image Index = 13
    IconNames.Add('LAN ');                   // Image Index = 14
    IconNames.Add('ϲ ߭ ');            // Image Index = 15
    IconNames.Add(' ');                 // Image Index = 16
    IconNames.Add('ȯܰ ߭ ');        // Image Index = 17
  end;
end;

{ Recs  i Ԗڂ̍ڂɊ֘AACRToÃCfbNXԍ }
{ Ԃ֐A֘AACRAIconNames ɂȂ -1 Ԃ܂B}
{ IconNames ɂ́AACR邢́AeACRɑΉt@C̊gq }
{ i[Ă܂B܂AG[̏ꍇɂ -1 Ԃ܂B}
function SearchImageIndex(Recs: TSearchRecs; i: Integer;
                          IconNames: TStringList): Integer;
var
  R: TSearchRec;
  Ext: String;
begin
  if (not Assigned(Recs)) or (not Assigned(IconNames)) then // G[
  begin
    Result := -1;
    Exit;
  end;
  R := TSearchRec(Recs.Items[i]^);
  if Recs.Path = '' then // Recs AhCui[Ăꍇ
    Result := R.Time // Member of Time has Image Index Number
  else if (R.Attr and faDirectory) > 0 then // tH_
    Result := 3
  else // ʏt@C
  begin
    Ext := LowerCase(ExtractFileExt(R.Name)) + ' '; //  ' '(Xy[X)tĒu
    Result := SearchString(Ext, IconNames);
  end;
end;

{ Recs  i Ԗڂ̍ڂɑΉACR̃CfbNXԍԂ֐A}
{ Ώۂ̃ACRAIcons ɂȂΐVɂ̃ACR擾A}
{ Icons ɒǉ܂B̂Ƃ IconNames ɂ́ÃACRɑΉ }
{ t@C̊gqAǉi[܂BG[̏ꍇ́A-1 Ԃ܂B}
function GetImageIndex(Recs: TSearchRecs; i: Integer;
                       var Icons: TImageList;
                       var IconNames: TStringList): Integer;
var
  R: TSearchRec;
  FileName: String;
  Ext: String;
  Icon: TIcon;
  iw: Word;
  Buffer: Array[0..1024] of Char;
  DefaultExt: String; // ŗL̃ACRȂt@C̊gq
  DefaultFile: Boolean; // ŗL̃ACRȂt@C
  ShowBitmap: Boolean; // rbg}bvt@CŗL̃ACR\
begin
  if (not Assigned(Recs)) or (not Assigned(Icons)) or
   (not Assigned(IconNames)) then // G[
  begin
    Result := -1;
    Exit;
  end;
  Result := SearchImageIndex(Recs, i, IconNames);
  if (Result in [0..1]) or (Result in [3..17]) then
    Exit;
  ShowBitmap := False; // rbg}bvt@CŗL̃ACR\ȂB
  // ŗL̃ACRȂA܂֘ÃACRȂ
  // t@B̊gqQ
  DefaultExt := '.com .bat .sys .ini .inf .txt .doc .xls .htm .html .lzh .zip .jpg .jpeg .wav .fnt ';
  if not ShowBitmap then
    DefaultExt := DefaultExt + '.bmp ';
  R := TSearchRec(Recs.Items[i]^);
  Ext := LowerCase(ExtractFileExt(R.Name)) + ' '; //  ' '(Xy[X)tĒu
  if AnsiPos(Ext, DefaultExt) = 0 then
    DefaultFile := False
  else
    DefaultFile := True;
  if (Result <> -1) and DefaultFile then
    Exit;
  FileName := ExtractFilePath(Recs.FullPath) + R.Name;
  Icon := TIcon.Create;
  if Result = -1 then
  begin
    if not DefaultFile then // t@CŗL̃ACR߂B
    begin
      try
        Icon.Handle := ExtractIcon(HInstance, PChar(FileName), 0);
        if Icon.Empty = False then // t@C̃ACRB
        begin
          Result := Icons.AddIcon(Icon);
          IconNames.Add(''); // ̃t@CŗL̃ACRłƂTC
          Icon.ReleaseHandle;
        end;
      except
        Icon.Free;
        Result := -1; // G[
        Exit;
      end;
    end;
    if Result = -1 then // ֘ÃACR߂B
    begin
      try
        if Ext = '.bmp ' then
        begin
          if FindExecutable(PChar(FileName), '', Buffer) > 32 then
            Icon.Handle := ExtractIcon(HInstance, Buffer, 0);
        end
        else
        begin
          if not Recs.InRecycle then
          begin
            iw := 0;
            Icon.Handle := ExtractAssociatedIcon(HInstance, PChar(FileName), iw);
          end;
        end;
        if Icon.Empty = False then // t@C֘ÃACRB
        begin
          Result := Icons.AddIcon(Icon);
          IconNames.Add(Ext); // ֘Ågq
          Icon.ReleaseHandle;
        end;
      except
        Icon.Free;
        Result := -1; // G[
        Exit;
      end;
    end;
    // ܂łɃACR炸S~̃t@CłȂꍇAȂ킿
    // ŗLE֘A̗ACRꍇA擪̃ACR֘AƂB
    if Result = -1 then
    begin
      Result := 0;
      if not Recs.InRecycle then
        IconNames.Strings[0] := IconNames.Strings[0] + Ext;
    end;
  end
  else
  begin
    try
      Icon.Handle := ExtractIcon(HInstance, PChar(FileName), 0);
      if Icon.Empty = False then // t@C̃ACRB
      begin
        Result := Icons.AddIcon(Icon);
        IconNames.Add(''); // ̃t@CŗL̃ACRłƂTC
        Icon.ReleaseHandle;
      end;
    except
      Icon.Free;
      Result := -1; // G[
      Exit;
    end;
  end;
  Icon.Free;
end;

{ Icons ̒t@CŗL̃ACR폜āA֘ÃACR݂̂ }
{ cׂ̎葱AȂ킿 IconNames 𒲂ׂăACR '' ̂ }
{ 폜܂B}
procedure SweepIcons(var Icons: TImageList; var IconNames: TStringList);
var
  i: Integer;
begin
  if (not Assigned(Icons)) or (not Assigned(IconNames)) then // G[
    Exit;
  i := Icons.Count - 1;
  while i >= 0 do
  begin
    if IconNames.Strings[i] = '' then // 󕶎̏ꍇ́AŗL̃ACR
    begin
      Icons.Delete(i);
      IconNames.Delete(i);
    end;
    Dec(i);
  end;
end;

{ ACȐݐLq IconName ÃACR }
{ nh߂ĂԂ֐ }
function StrToIcon(IconName: String): HIcon;
var
  i, j: Integer;
begin
  Result := 0;
  if IconName = '' then
    Exit;
  IconName := TakeOff('"', IconName); // " 菜

  if AnsiPos(',', IconName) > 0 then
  begin
    i := AnsiPos(',', IconName);
    j := StrToInt(Copy(IconName, i + 1, Length(IconName) - i));
    Result := ExtractIcon(HInstance, PChar(Copy(IconName, 1, i - 1)), j);
  end
  else
    Result := ExtractIcon(HInstance, PChar(IconName), 0);
end;

function IntToCStr(Value: Longint): String;
var
  Tmp: Single;
begin
  Tmp := Value;
  Result := Format('%.0n', [Tmp]);
end;

{ Strs ̒ SubStr ܂ލŏ̗vfToÃCfbNX }
{ ԍԂ֐AȂꍇ́A-1 Ԃ܂B}
{ ܂AG[̏ꍇɂ -1 Ԃ܂B}
function SearchString(SubStr: String; Strs: TStringList): Integer;
var
  i: Integer;
begin
  Result := -1;
  if (SubStr = '') or (not Assigned(Strs)) then // G[
    Exit;
  for i := 0 to Strs.Count - 1 do
  begin
    if AnsiPos(SubStr, Strs.Strings[i]) <> 0 then
    begin
      Result := i;
      Break;
    end;
  end;
end;

{  S 畔 SubStr 菜Ԃ֐ }
function TakeOff(SubStr: String; S: String): String;
var
  i, j, c: Integer;
  Done: Boolean;
begin
  if (SubStr = '') or (S = '') or (Length(SubStr) > Length(S)) then
  begin
    Result := S;
    Exit;
  end
  else
    Result := '';

  c := Length(S) - Length(SubStr) + 1;
  i := 1;
  while i <= Length(S) do
  begin
    Done := False;
    if (i <= c) and (S[i] = SubStr[1]) then
    begin
      Done := True;
      for j := 2 to Length(SubStr) do
      begin
        if S[i + j - 1] <> SubStr[j] then
        begin
          Done := False; // ́̕Ał͂ȂB
          Break;
        end;
      end;
    end;
    if Done = False then
      Result := Result + S[i]
    else
      i := i + Length(SubStr) - 1;
    Inc(i);
  end;
end;

{  S 畔 SubStr 菜Ԃ֐ }
function TakeAway(SubStr: String; S: String): String;
begin
  Result := '';
  while AnsiPos(SubStr, S) > 0 do
  begin
    Result := Result + Copy(S, 1, AnsiPos(SubStr, S) - 1);
    Delete(S, 1, AnsiPos(SubStr, S) + Length(SubStr) - 1);
  end;
  Result := Result + S;
end;

{ BM@ɂ蕶 S ̐擪畔 SubStr A}
{ ʒuԂ֐łBȂꍇ́A0 Ԃ܂B}
{ MatchCase  False ̏ꍇ́ApAt@xbg̑啶Ə }
{ ʂ܂B}
function BMPos(SubStr: String; S: String; MatchCase: Boolean): Integer;
var
  Chi, Cht: Char;
  i, j, k, n: Integer;
  Len, SubLen: Integer;
begin
  Result := 0; // Ȃꍇ̖߂l
  SubLen := Length(SubStr);
  Len := Length(S);
  if (SubLen = 0) or (Len = 0) or (SubLen > Len) then
    Exit;
  if MatchCase = True then
  begin
    Cht := SubStr[SubLen]; // Ώۂ̍Ō̕
    i := SubLen; // X^[gn_
    while i <= Len do
    begin
      Chi := S[i]; // n_̍Ō̕
      if Chi = Cht then // Ō̕ǂvB
      begin
        k := i - 1;
        for j := SubLen - 1 downto 1 do
        begin
          if S[k] <> SubStr[j] then
            Break;
          Dec(k);
        end;
        if k = i - SubLen then // B
        begin
          Result := i - SubLen + 1;
          Break;
        end
        else
        begin
          Chi := S[k]; // vȂn_̕
          n := 0;
          for j := SubLen downto 1 do
          begin
            if Chi = SubStr[j] then
              Break;
            Inc(n);
          end;
          if k + n > i then
            i := k + n // ̈ʒü݂ʒu傫΂̈ʒu
          else
            Inc(i); // łȂ΁Aʒui߂B
        end;
      end
      else
      begin
        k := 1;
        for j := SubLen - 1 downto 1 do
        begin
          if Chi = SubStr[j] then
            Break;
          Inc(k);
        end;
        i := i + k; // ̈ʒu
      end;
    end;
  end
  else
  begin
    SubStr := UpperCase(SubStr); // 啶ɕϊB
    Cht := SubStr[SubLen]; // Ώۂ̍Ō̕
    i := SubLen; // X^[gn_
    while i <= Len do
    begin
      Chi := UpCase(S[i]); // n_̍Ō̕
      if Chi = Cht then // Ō̕ǂvB
      begin
        k := i - 1;
        for j := SubLen - 1 downto 1 do
        begin
          if UpCase(S[k]) <> SubStr[j] then
            Break;
          Dec(k);
        end;
        if k = i - SubLen then // B
        begin
          Result := i - SubLen + 1;
          Break;
        end
        else
        begin
          Chi := UpCase(S[k]); // vȂn_̕
          n := 0;
          for j := SubLen downto 1 do
          begin
            if Chi = SubStr[j] then
              Break;
            Inc(n);
          end;
          if k + n > i then
            i := k + n // ̈ʒü݂ʒu傫΂̈ʒu
          else
            Inc(i); // łȂ΁Aʒui߂B
        end;
      end
      else
      begin
        k := 1;
        for j := SubLen - 1 downto 1 do
        begin
          if Chi = SubStr[j] then
            Break;
          Inc(k);
        end;
        i := i + k; // ̈ʒu
      end;
    end;
  end;
end;

{ BM@ɂ蕶 S ̖畔 SubStr A}
{ ʒuԂ֐łBȂꍇ́A0 Ԃ܂B}
{ MatchCase  False ̏ꍇ́ApAt@xbg̑啶Ə }
{ ʂ܂B}
function RBMPos(SubStr: String; S: String; MatchCase: Boolean): Integer;
var
  Chi, Chh: Char;
  i, j, k, n: Integer;
  Len, SubLen: Integer;
begin
  Result := 0; // Ȃꍇ̖߂l
  SubLen := Length(SubStr);
  Len := Length(S);
  if (SubLen = 0) or (Len = 0) or (SubLen > Len) then
    Exit;
  if MatchCase = True then
  begin
    Chh := SubStr[1]; // Ώۂ̐擪̕
    i := Len - SubLen + 1; // X^[gn_
    while i >= 1 do
    begin
      Chi := S[i]; // n_̐擪̕
      if Chi = Chh then // 擪̕ǂvB
      begin
        k := i + 1;
        for j := 2 to SubLen do
        begin
          if S[k] <> SubStr[j] then
            Break;
          Inc(k);
        end;
        if k = i + SubLen then // B
        begin
          Result := i;
          Break;
        end
        else
        begin
          Chi := S[k]; // vȂn_̕
          n := 0;
          for j := 1 to SubLen do
          begin
            if Chi = SubStr[j] then
              Break;
            Inc(n);
          end;
          if k - n < i then
            i := k - n // ̈ʒü݂ʒu菬΂̈ʒu
          else
            Dec(i); // łȂ΁AʒuB
        end;
      end
      else
      begin
        k := 1;
        for j := 2 to SubLen do
        begin
          if Chi = SubStr[j] then
            Break;
          Inc(k);
        end;
        i := i - k; // ̈ʒu
      end;
    end;
  end
  else
  begin
    SubStr := UpperCase(SubStr); // 啶ɕϊB
    Chh := SubStr[1]; // Ώۂ̐擪̕
    i := Len - SubLen + 1; // X^[gn_
    while i >= 1 do
    begin
      Chi := UpCase(S[i]); // n_̐擪̕
      if Chi = Chh then // 擪̕ǂvB
      begin
        k := i + 1;
        for j := 2 to SubLen do
        begin
          if UpCase(S[k]) <> SubStr[j] then
            Break;
          Inc(k);
        end;
        if k = i + SubLen then // B
        begin
          Result := i;
          Break;
        end
        else
        begin
          Chi := UpCase(S[k]); // vȂn_̕
          n := 0;
          for j := 1 to SubLen do
          begin
            if Chi = SubStr[j] then
              Break;
            Inc(n);
          end;
          if k - n < i then
            i := k - n // ̈ʒü݂ʒu菬΂̈ʒu
          else
            Dec(i); // łȂ΁AʒuB
        end;
      end
      else
      begin
        k := 1;
        for j := 2 to SubLen do
        begin
          if Chi = SubStr[j] then
            Break;
          Inc(k);
        end;
        i := i - k; // ̈ʒu
      end;
    end;
  end;
end;

{  S ̒畔 SubStr AʒuԂ֐łB}
{ ͈́ÉAIndex ==> Length(S) - Length(SubStr) + 1łB}
{ Ȃꍇ́A0 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function PosI(SubStr: String; S: String; Index: Integer; MatchCase: Boolean): Integer;
var
  CSubStr: String;
  CS: String;
begin
  Result := 0; // Ȃꍇ̖߂l
  if (SubStr = '') or (S = '') or (Index < 1) or
     (Index + Length(SubStr) - 1 > Length(S)) then
    Exit;

  CSubStr := SubStr;
  CS := S;
  CS := Copy(CS, Index, Length(CS) - Index + 1);
  Result := BMPos(CSubStr, CS, MatchCase);
  if Result <> 0 then // B
    Result := Result + Index - 1;
end;

{  S ̒畔 SubStr AʒuԂ֐łB}
{ ͈́ÉAIndex1 ==> Index2 ŁAIndex1 <= Index2 łȂ΂Ȃ }
{ BȂꍇ́A0 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function PosIn(SubStr: String; S: String; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
var
  CSubStr: String;
  CS: String;
begin
  Result := 0; // Ȃꍇ̖߂l
  if (SubStr = '') or (S = '') or (Index1 < 1) or (Index2 < 1) or
     (Index1 > Index2) or (Index1 + Length(SubStr) - 1 > Length(S)) then
    Exit;

  CSubStr := SubStr;
  CS := S;
  CS := Copy(CS, Index1, Index2 - Index1 + 1 + Length(CSubStr));
  Result := BMPos(CSubStr, CS, MatchCase);
  if Result <> 0 then // B
    Result := Result + Index1 - 1;
end;

{  S ̒畔 SubStr AʒuԂ֐łB}
{ ͈́ÉA1 <== IndexłBȂꍇ́A0 Ԃ܂B}
{ MatchCase  False ̏ꍇ́ApAt@xbg̑啶Ə }
{ ʂ܂B}
function RPosI(SubStr: String; S: String; Index: Integer; MatchCase: Boolean): Integer;
var
  CSubStr: String;
  CS: String;
begin
  Result := 0; // Ȃꍇ̖߂l
  if (SubStr = '') or (S = '') or (Index < 1) or
     (Index + Length(SubStr) - 1 > Length(S)) then
    Exit;

  CSubStr := SubStr;
  CS := S;
  CS := Copy(CS, 1, Index + Length(CSubStr) - 1);
  Result := RBMPos(CSubStr, CS, MatchCase);
end;

{  S ̒畔 SubStr AʒuԂ֐łB}
{ ͈́ÉAIndex1 <== Index2 ŁAIndex1 <= Index2 łȂ΂Ȃ }
{ BȂꍇ́A0 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function RPosIn(SubStr: String; S: String; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
var
  CSubStr: String;
  CS: String;
begin
  Result := 0; // Ȃꍇ̖߂l
  if (SubStr = '') or (S = '') or (Index1 < 1) or (Index2 < 1) or
     (Index1 > Index2) or (Index1 + Length(SubStr) - 1 > Length(S)) or
     (Index2 + Length(SubStr) - 1 > Length(S)) then
    Exit;

  CSubStr := SubStr;
  CS := S;
  CS := Copy(CS, Index1, Index2 - Index1 + 1 + Length(SubStr));
  Result := RBMPos(CSubStr, CS, MatchCase);
  if Result <> 0 then // B
    Result := Result + Index1 - 1;
end;

{  S ɂ镔 FindText S ReplaceText ŒuA}
{ uԂ֐łBMatchCase  False ̏ꍇ́AS  FindText  }
{ pAt@xbg̑啶Əʂ܂B}
function ReplaceString(var S: String; FindText: String; ReplaceText: String; MatchCase: Boolean): Integer;
var
  i, j: Integer;
  RS: String;
begin
  Result := 0;
  if (S = '') or (FindText = '') then
    Exit;
  i := 1;
  j := 1;
  RS := '';
  while j <> 0 do
  begin
    j := PosI(FindText, S, i, MatchCase);
    if j <> 0 then
    begin
      RS := RS + Copy(S, i, j - i) + ReplaceText;
      i := j + Length(FindText);
      Inc(Result);
    end;
  end;
  if Result <> 0 then
    S := RS + Copy(S, i, Length(S) - i + 1);
end;

{ P  Index oCgڂ̕啶ɕϊ֐łB}
{ 2 oCgR[hɑ΂ΐAsȂ܂B}
function UpCaseX(P: PChar; Index: Integer): Char;
begin
  Result := P[Index];
  if (Result in ['a'..'z']) and (StrByteType(P, Index) = mbSingleByte) then
    Result := Char(Integer(Result) - $20); // 啶ɕϊ
end;

{ P ̏啶ɕϊ葱łB}
{ 2 oCgR[h̏ɑ΂ΐAsȂ܂B}
procedure UpperCaseX(P: PChar; Len: Integer);
var
  i: Integer;
  knj: Boolean;
begin
  knj := False;
  for i := 0 to Len - 1 do
  begin
    if knj then
      knj := False
    else
    begin
      if Integer(P[i]) in Kanji1Data then
        knj := True
      else if P[i] in ['a'..'z'] then
        P[i] := Char(Integer(P[i]) - $20); // 啶ɕϊ
    end;
  end;
end;

{ BM@ɂ P ̐擪畔f[^ Sub AʒuԂ }
{ ֐łBȂꍇ́A-1 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function BMPosX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; MatchCase: Boolean): Integer;
var
  Chi, Cht: Char;
  i, j, k, n: Integer;
  Temp: PChar;
begin
  Result := -1; // Ȃꍇ̖߂l
  if (Sub = Nil) or (SubLen <= 0) or (P = Nil) or (Len <= 0)
   or (SubLen > Len) then
    Exit;
  if MatchCase = True then
  begin
    Cht := Sub[SubLen - 1]; // Ώۂ̍Ō̃f[^
    i := SubLen - 1; // X^[gn_
    while i < Len do
    begin
      Chi := P[i]; // n_̍Ō̃f[^
      if Chi = Cht then // Ō̃f[^ǂvB
      begin
        k := i - 1;
        for j := SubLen - 2 downto 0 do
        begin
          if P[k] <> Sub[j] then
            Break;
          Dec(k);
        end;
        if k = i - SubLen then // B
        begin
          Result := i - SubLen + 1;
          Break;
        end
        else
        begin
          Chi := P[k]; // vȂn_̃f[^
          n := 0;
          for j := SubLen - 1 downto 0 do
          begin
            if Chi = Sub[j] then
              Break;
            Inc(n);
          end;
          if k + n > i then
            i := k + n // ̈ʒü݂ʒu傫΂̈ʒu
          else
            Inc(i); // łȂ΁Aʒui߂B
        end;
      end
      else
      begin
        k := 1;
        for j := SubLen - 2 downto 0 do
        begin
          if Chi = Sub[j] then
            Break;
          Inc(k);
        end;
        i := i + k; // ̈ʒu
      end;
    end;
  end
  else
  begin
    Temp := Nil;
    ReallocMem(Temp, SubLen);
    CopyMemory(Temp, Sub, SubLen); // Sub ̃f[^ۑĂ
    UpperCaseX(Sub, SubLen); // 啶ɕϊB
    Cht := Sub[SubLen - 1]; // Ώۂ̍Ō̃f[^
    i := SubLen - 1; // X^[gn_
    while i < Len do
    begin
      Chi := UpCaseX(P, i); // n_̍Ō̃f[^
      if Chi = Cht then // Ō̃f[^ǂvB
      begin
        k := i - 1;
        for j := SubLen - 2 downto 0 do
        begin
          if UpCaseX(P, k) <> Sub[j] then
            Break;
          Dec(k);
        end;
        if k = i - SubLen then // B
        begin
          Result := i - SubLen + 1;
          Break;
        end
        else
        begin
          Chi := UpCaseX(P, k); // vȂn_̃f[^
          n := 0;
          for j := SubLen - 1 downto 0 do
          begin
            if Chi = Sub[j] then
              Break;
            Inc(n);
          end;
          if k + n > i then
            i := k + n // ̈ʒü݂ʒu傫΂̈ʒu
          else
            Inc(i); // łȂ΁Aʒui߂B
        end;
      end
      else
      begin
        k := 1;
        for j := SubLen - 2 downto 0 do
        begin
          if Chi = Sub[j] then
            Break;
          Inc(k);
        end;
        i := i + k; // ̈ʒu
      end;
    end;
    CopyMemory(Sub, Temp, SubLen); // Sub ̃f[^ƂɂǂĂ
    ReallocMem(Temp, 0); // Free Memory
  end;
end;

{ BM@ɂ P ̖畔f[^ Sub AʒuԂ }
{ ֐łBȂꍇ́A-1 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function RBMPosX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; MatchCase: Boolean): Integer;
var
  Chi, Chh: Char;
  i, j, k, n: Integer;
  Temp: PChar;
begin
  Result := -1; // Ȃꍇ̖߂l
  if (Sub = Nil) or (SubLen <= 0) or (P = Nil) or (Len <= 0)
   or (SubLen > Len) then
    Exit;
  if MatchCase = True then
  begin
    Chh := Sub[0]; // Ώۂ̐擪̃f[^
    i := Len - SubLen; // X^[gn_
    while i >= 0 do
    begin
      Chi := P[i]; // n_̐擪̃f[^
      if Chi = Chh then // 擪̃f[^ǂvB
      begin
        k := i + 1;
        for j := 1 to SubLen - 1 do
        begin
          if P[k] <> Sub[j] then
            Break;
          Inc(k);
        end;
        if k = i + SubLen then // B
        begin
          Result := i;
          Break;
        end
        else
        begin
          Chi := P[k]; // vȂn_̃f[^
          n := 0;
          for j := 0 to SubLen - 1 do
          begin
            if Chi = Sub[j] then
              Break;
            Inc(n);
          end;
          if k - n < i then
            i := k - n // ̈ʒü݂ʒu菬΂̈ʒu
          else
            Dec(i); // łȂ΁AʒuB
        end;
      end
      else
      begin
        k := 1;
        for j := 1 to SubLen - 1 do
        begin
          if Chi = Sub[j] then
            Break;
          Inc(k);
        end;
        i := i - k; // ̈ʒu
      end;
    end;
  end
  else
  begin
    Temp := Nil;
    ReallocMem(Temp, SubLen);
    CopyMemory(Temp, Sub, SubLen); // Sub ̃f[^ۑĂ
    UpperCaseX(Sub, SubLen); // 啶ɕϊB
    Chh := Sub[0]; // Ώۂ̐擪̃f[^
    i := Len - SubLen; // X^[gn_
    while i >= 0 do
    begin
      Chi := UpCaseX(P, i); // n_̐擪̃f[^
      if Chi = Chh then // 擪̃f[^ǂvB
      begin
        k := i + 1;
        for j := 1 to SubLen - 1 do
        begin
          if UpCaseX(P, k) <> Sub[j] then
            Break;
          Inc(k);
        end;
        if k = i + SubLen then // B
        begin
          Result := i;
          Break;
        end
        else
        begin
          Chi := UpCaseX(P, k); // vȂn_̃f[^
          n := 0;
          for j := 0 to SubLen - 1 do
          begin
            if Chi = Sub[j] then
              Break;
            Inc(n);
          end;
          if k - n < i then
            i := k - n // ̈ʒü݂ʒu菬΂̈ʒu
          else
            Dec(i); // łȂ΁AʒuB
        end;
      end
      else
      begin
        k := 1;
        for j := 1 to SubLen - 1 do
        begin
          if Chi = Sub[j] then
            Break;
          Inc(k);
        end;
        i := i - k; // ̈ʒu
      end;
    end;
    CopyMemory(Sub, Temp, SubLen); // Sub ̃f[^ƂɂǂĂ
    ReallocMem(Temp, 0); // Free Memory
  end;
end;

{ P ̒畔f[^ Sub AʒuԂ֐łB}
{ ͈́ÉAIndex ==> Len - SubLen łB}
{ Ȃꍇ́A-1 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function PosIX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index: Integer; MatchCase: Boolean): Integer;
begin
  Result := -1; // Ȃꍇ̖߂l
  if (Sub = Nil) or (SubLen <= 0) or (P = Nil) or (Len <= 0) or
     (Index < 0) or (Index > Len - SubLen) then
    Exit;
  Result := BMPosX(Sub, SubLen, P + Index, Len - Index, MatchCase);
  if Result <> -1 then // B
    Result := Result + Index;
end;

{ P ̒畔f[^ Sub AʒuԂ֐łB}
{ ͈́ÉAIndex1 ==> Index2 ŁAIndex1 <= Index2 łȂ΂Ȃ }
{ BȂꍇ́A-1 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function PosInX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
begin
  Result := -1; // Ȃꍇ̖߂l
  if (Sub = Nil) or (SubLen <= 0) or (P = Nil) or (Len <= 0) or (Index1 < 0) or
     (Index2 < 0) or (Index1 > Index2) or (Index1 > Len - SubLen) then
    Exit;
  Result := BMPosX(Sub, SubLen, P + Index1, Index2 - Index1 + 1 + SubLen - 1,
   MatchCase);
  if Result <> 0 then // B
    Result := Result + Index1;
end;

{ P ̒畔f[^ Sub AʒuԂ֐łB}
{ ͈́ÉA0 <== IndexłBȂꍇ́A-1 Ԃ܂B}
{ MatchCase  False ̏ꍇ́ApAt@xbg̑啶Ə }
{ ʂ܂B}
function RPosIX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index: Integer; MatchCase: Boolean): Integer;
begin
  Result := -1; // Ȃꍇ̖߂l
  if (Sub = Nil) or (SubLen <= 0) or (P = Nil) or (Len <= 0) or
     (Index < 0) or (Index > Len - SubLen) then
    Exit;
  if Index + SubLen < Len then
    Len := Index + SubLen;
  Result := RBMPosX(Sub, SubLen, P, Len, MatchCase);
end;

{ P ̒畔f[^ Sub AʒuԂ֐łB}
{ ͈́ÉAIndex1 <== Index2 ŁAIndex1 <= Index2 łȂ΂Ȃ }
{ BȂꍇ́A-1 Ԃ܂BMatchCase  False ̏ꍇ́A}
{ pAt@xbg̑啶Əʂ܂B}
function RPosInX(Sub: PChar; SubLen: Integer; P: PChar; Len: Integer; Index1: Integer; Index2: Integer; MatchCase: Boolean): Integer;
begin
  Result := -1; // Ȃꍇ̖߂l
  if (Sub = Nil) or (SubLen <= 0) or (P = Nil) or (Len <= 0) or
     (Index1 > Index2) or
     (Index1 < 0) or (Index1 > Len - SubLen) or
     (Index2 < 0) or (Index2 > Len - SubLen)then
    Exit;
  if Index2 + SubLen < Len then
    Len := Index2 + SubLen;
  Result := RBMPosX(Sub, SubLen, P + Index1, Len - Index1, MatchCase);
  if Result <> -1 then // B
    Result := Result + Index1;
end;

{ P ̒ɂ镔f[^ FindData S ReplaceData ŒuAu }
{ Ԃ֐łBMatchCase  False ̏ꍇ́AP  FindData  }
{ pAt@xbg̑啶Əʂ܂B}
function ReplaceDataX(var P: PChar; var Len: Integer; FindData: PChar; FindLen: Integer; ReplaceData: PChar; ReplaceLen: Integer; MatchCase: Boolean): Integer;
var
  i, j, k: Integer;
  RP: PChar;
begin
  Result := 0;
  if (P = Nil) or (Len <= 0) or (FindData = Nil) or (FindLen <= 0) or
   (ReplaceLen < 0) then
    Exit;
  if ReplaceData = Nil then
    ReplaceLen := 0;
  i := 0;
  j := 0;
  k := 0;
  RP := Nil;
  while j <> -1 do
  begin
    j := PosIX(FindData, FindLen, P, Len, i, MatchCase);
    if j <> -1 then
    begin
      ReallocMem(RP, k + (j - i) + ReplaceLen);
      CopyMemory(RP + k, P + i, j - i);
      CopyMemory(RP + k + (j - i), ReplaceData, ReplaceLen);
      k := k + (j - i) + ReplaceLen;
      i := j + FindLen;
      Inc(Result);
    end;
  end;
  if Result <> 0 then
  begin
    ReallocMem(RP, k + (Len - i));
    CopyMemory(RP + k, P + i, Len - i);
    Len := k + (Len - i); // P ̐VTCY
    ReallocMem(P, Len + 4); // 4 oCg]vɊmۂB
    CopyMemory(P, RP, Len);
    P[Len] := #0;
    P[Len + 1] := #0;
    P[Len + 2] := #0;
    P[Len + 3] := #0;
    ReallocMem(RP, 0); // Free Memory
  end;
end;

{ TSearchRecs }

constructor TSearchRecs.Create;
begin
  inherited Create;
  FPath := '';
  FFullPath := ' ';
  FAttr := faAnyFile;
  FSortType := stName or stDirectory;
  FInRecycle := False;
end;

destructor TSearchRecs.Destroy;
begin
  Clear;
  inherited Destroy;
end;

function TSearchRecs.Add(const Rec: TSearchRec): Integer;
var
  Tmp: ^TSearchRec;
begin
  New(Tmp);
  Tmp^ := Rec;
  Result := inherited Add(Tmp);
end;

procedure TSearchRecs.Clear;
var
  i: Integer;
begin
  for i := (Count - 1) downto 0 do
    Delete(i);
  inherited Clear;
end;

procedure TSearchRecs.Delete(Index: Integer);
begin
  Dispose(Items[Index]);
  inherited Delete(Index);
end;

function TSearchRecs.IndexOf(const FileName: TFileName): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := 0 to Count - 1 do
  begin
    if AnsiCompareFileName(Recs[i].Name, FileName) = 0 then
    begin
      Result := i;
      Break;
    end;
  end;
end;

procedure TSearchRecs.Insert(Index: Integer; const Rec: TSearchRec);
var
  Tmp: ^TSearchRec;
begin
  New(Tmp);
  Tmp^ := Rec;
  inherited Insert(Index, Tmp);
end;

function CompareName(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TSearchRec;
begin
  rec1 := TSearchRec(Item1^);
  rec2 := TSearchRec(Item2^);

  Result := AnsiCompareFileName(rec1.Name, rec2.Name);
end;

function CompareSize(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TSearchRec;
begin
  Result := 0;
  rec1 := TSearchRec(Item1^);
  rec2 := TSearchRec(Item2^);

  if rec1.Size > rec2.Size then
    Result := 1
  else if rec1.Size < rec2.Size then
    Result := -1;
end;

function CompareTime(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TSearchRec;
begin
  rec1 := TSearchRec(Item1^);
  rec2 := TSearchRec(Item2^);

  Result := rec1.Time - rec2.Time;
end;

procedure TSearchRecs.SortRec;
begin
  if (Count <= 1) or ((FSortType and stSomeSort) = 0) then
    Exit; // Lȃ\[głȂꍇ

  if (FSortType and stName) > 0 then
    inherited Sort(CompareName)
  else if (FSortType and stSize) > 0 then
    inherited Sort(CompareSize)
  else if (FSortType and stTime) > 0 then
    inherited Sort(CompareTime);

  if (FSortType and stReverse) > 0 then
    ReverseRec; // Xg̏ԂtɂB

  if (FSortType and stDirectory) > 0 then
    ForwardDirectory; // Xg̃fBNgOɋl߂B
end;

procedure TSearchRecs.Refresh;
begin
  GetFiles;
end;

procedure TSearchRecs.SetPath(const Value: String);
begin
  if (FPath <> Value) or (Value = '') then
  begin
    FPath := Value;
    if FPath = '' then
      FFullPath := ' '
    else
      FFullPath := ExpandFileName(FPath);
    FInRecycle := CheckInRecycle;
    GetFiles;
  end;
end;

procedure TSearchRecs.SetAttr(const Value: Integer);
begin
  if FAttr <> Value then
  begin
    FAttr := Value;
    GetFiles;
  end;
end;

procedure TSearchRecs.SetSortType(const Value: Integer);
begin
  if FSortType <> Value then
  begin
    FSortType := Value;
    SortRec;
  end;
end;

function TSearchRecs.GetRec(Index: Integer): TSearchRec;
begin
  Result := TSearchRec(Items[Index]^);
end;

procedure TSearchRecs.PutRec(Index: Integer; const Rec: TSearchRec);
begin
  TSearchRec(Items[Index]^) := Rec;
end;

{ ݂ Path AS~tH_̂̂ł邩ǂ }
{ `FbN֐ }
function TSearchRecs.CheckInRecycle: Boolean;
var
  i: Integer;
  OldMode: Integer;
  R: TSearchRec;
  TopPath: String;
begin
  Result := False;
  i := AnsiPos(':\', FFullPath);
  if i = 0 then
    Exit;
  i := i + 2;
  if (FFullPath[i] <> 'r') and (FFullPath[i] <> 'R') then
    Exit;
  while i <= Length(FFullPath) do
  begin
    if FFullPath[i] = '\' then
      Break;
    Inc(i);
  end;
  Dec(i);
  TopPath := Copy(FFullPath, 1, i);
  OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  i := FindFirst(TopPath, faAnyFile, R);
  SetErrorMode(OldMode);
  if i = 0 then
  begin
    if ((R.Attr and faDirectory) > 0) and ((R.Attr and faHidden) > 0)
     and ((R.Attr and faSysFile) > 0) then
      Result := True;
    FindClose(R);
  end;
end;

{ Xg̏Ԃtɂׂ̎葱 }
procedure TSearchRecs.ReverseRec;
var
  i, j: Integer;
begin
  i := 0;
  j := Count - 1;
  while i < j do
  begin
    Exchange(i, j);
    Inc(i);
    Dec(j);
  end;
end;

{ Xg̃fBNgOɋl߂ׂ̎葱 }
procedure TSearchRecs.ForwardDirectory;
var
  i, j: Integer;
begin
  i := 0;
  while i < Count do
  begin
    if (Recs[i].Attr and faDirectory) = 0 then // ʏt@C
    begin
      j := i + 1;
      while j < Count do
      begin
        if (Recs[j].Attr and faDirectory) > 0 then // fBNg
        begin
          Move(j, i);
          Break;
        end;
        Inc(j);
      end;
      if j = Count then
        Break;
    end;
    Inc(i);
  end;
end;

procedure TSearchRecs.GetFiles;
var
  i: Integer;
  OldMode: Integer;
  R: TSearchRec;
  Drive: String;
  d: Char;
  DN: Byte;
  DS: Int64;
begin
  if FFullPath = '' then // ȂB
    Exit;
  Clear;
  if FPath = '' then // hCu𓾂B
  begin
    FillChar(R, SizeOf(TSearchRec), 0);
    Drive := 'A:';
    for d := Char('A') to Char('Z') do
    begin
      Drive[1] := d;
      OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
      i := Integer(GetDriveType(PChar(Drive + '\')));
      SetErrorMode(OldMode);
      if i > 1 then
      begin
        R.Attr := i;       // Set Drive Type to Member of Attr
        case R.Attr of
          DRIVE_REMOVABLE: // The drive can be removed from the drive.
          begin
            if d < Char('C') then
            begin
              R.Name := Drive + ' ۯ߰ި';   // Set Drive Name
              R.Time := 6; // Set Image Index Number to Member of Time
            end
            else
            begin
              R.Name := Drive + ' Ѱި'; // Set Drive Name
              R.Time := 7; // Set Image Index Number to Member of Time
            end;
          end;
          DRIVE_FIXED:     // The disk cannot be removed from the drive.
          begin
            R.Name := Drive + ' Œި';       // Set Drive Name
            R.Time := 8;   // Set Image Index Number to Member of Time
          end;
          DRIVE_REMOTE:    // The drive is a remote (network) drive.
          begin
            R.Name := Drive + ' ȯܰײ';          // Set Drive Name
            R.Time := 9;   // Set Image Index Number to Member of Time
          end;
          DRIVE_CDROM:     // The drive is a CD-ROM drive.
          begin
            R.Name := Drive + ' CD-ROM';          // Set Drive Name
            R.Time := 11;  // Set Image Index Number to Member of Time
          end;
          DRIVE_RAMDISK:   // The drive is a RAM disk.
          begin
            R.Name := Drive + ' RAM ި';       // Set Drive Name
            R.Time := 12;  // Set Image Index Number to Member of Time
          end;
          else             // The drive is a Unknown Drive.
          begin
            R.Name := Drive + ' sײ';    // Set Drive Name
            R.Time := 10;  // Set Image Index Number to Member of Time
          end;
        end;
        DN := Byte(d) - Byte('A') + 1;
        OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
        DS := DiskSize(DN);
        SetErrorMode(OldMode);
        if DS = -1 then
          R.Size := -1     // When Incorrect Drive
        else
        begin
          R.Size := DS div (1024 * 1024); // Set Drive Size Per MB
          if DS mod (1024 * 1024) <> 0 then
            Inc(R.Size);
        end;
        Add(R);
      end;
    end;
  end
  else // t@C𓾂B
  begin
    OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
    i := FindFirst(FPath, FAttr, R);
    SetErrorMode(OldMode);
    try
      while i = 0 do
      begin
        if (R.Name <> '.') and (R.Name <> '..') then
          Add(R);
        i := FindNext(R);
      end;
    finally
      FindClose(R);
    end;
    SortRec;
  end;
  Pack; // Items z񂩂炷ׂĂ Nil ڂ폜B
  Capacity := Count; // Pack ɂč폜ꂽgp̃GgB
end;

{ TExtensionRecs }

constructor TExtensionRecs.Create;
begin
  inherited Create;
  FIcon := TIcon.Create;
  FPerceivedSystem := False;
  FSortType := idExtension;
  FSorted := False;
  GetExtensions;
end;

destructor TExtensionRecs.Destroy;
begin
  Clear;
  FIcon.Free;
  inherited Destroy;
end;

function TExtensionRecs.Add(const Rec: TExtensionRec): Integer;
var
  Tmp: PExtensionRec;
begin
  New(Tmp);
  Tmp^ := Rec;
  Result := inherited Add(Tmp);
  FSorted := False;
end;

procedure TExtensionRecs.Clear;
var
  i: Integer;
begin
  for i := (Count - 1) downto 0 do
    Delete(i);
  inherited Clear;
  FPerceivedSystem := False;
  FSorted := False;
end;

procedure TExtensionRecs.Delete(Index: Integer);
begin
  Dispose(Items[Index]);
  inherited Delete(Index);
end;

procedure TExtensionRecs.Exchange(Index1, Index2: Integer);
begin
  inherited Exchange(Index1, Index2);
  FSorted := False;
end;

function TExtensionRecs.Find(const S: String; idType: TidType; var Index: Integer): Boolean;
var
  left, right, center, compare: Integer;
  M: String;
begin
  Result := False;
  Index := Count;
  M := '';
  if Count = 0 then
    Exit;

  if idType <> FSortType then // T[`ƃ\[gقȂꍇ
  begin
    Index := Search(0, S, idType);
    if Index = -1 then
      Index := Count
    else
      Result := True;
    Exit;
  end;

  left := 0;
  right := Count - 1;

  while left <= right do
  begin
    center := (left + right) shr 1;
    case idType of
      idExtension:     M := Recs[center].Extension;
      idCommand:       M := Recs[center].Command;
      idDefaultIcon:   M := Recs[center].DefaultIcon;
      idExtensionKey:  M := Recs[center].ExtensionKey;
      idExtensionName: M := Recs[center].ExtensionName;
      idContentType:   M := Recs[center].ContentType;
      idPerceivedType: M := Recs[center].PerceivedType;
    else
      Break;
    end;
    compare := AnsiCompareText(M, S);
    if compare < 0 then
      left := center + 1
    else
    begin
      right := center - 1;
      if compare = 0 then
        Result := True;
    end;
  end;

  { S Ȃꍇ́AIndex ̒l S ̑}|CgƂȂB}
  Index := left
end;

procedure TExtensionRecs.GetExtensions;
var
  i, k: Integer;
  s: Integer;
  Error: Boolean;
  R: TExtensionRec;
  KeyNames: TStringList;
  Reg: TRegistry;
begin
  Clear;
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  KeyNames := TStringList.Create;

  Error := False;
  try
    if Reg.OpenKey('\', False) = True then
      Reg.GetKeyNames(KeyNames)
    else
      Error := True;
  finally
    Reg.CloseKey;
  end;
  if Error = True then
  begin
    KeyNames.Free;
    Reg.Free;
    Exit;
  end;

  KeyNames.Sort; // ܂A\[gB
  s := -1;
  for i := 0 to KeyNames.Count - 1 do
  begin
    if (KeyNames[i])[1] = '.' then
    begin
      if (Length(KeyNames[i]) > 1) and ((KeyNames[i])[2] <> '.') then
      begin
        s := i; // 擪̊gq̃CfbNXԍ
        Break;
      end;
    end;
  end;
  if s = -1 then
  begin
    KeyNames.Free;
    Reg.Free;
    Exit;
  end;

  i := s;
  s := -1;
  while i < KeyNames.Count do
  begin
    if (KeyNames[i])[1] <> '.' then // gqł͂ȂB
    begin
      s := i; // 擪̊gqL[̃CfbNXԍ
      Break;
    end;
    R.Extension := KeyNames[i];
    R.Command := '';
    R.DefaultIcon := '';
    R.ExtensionKey := '';
    R.ExtensionName := '';
    R.ContentType := '';
    R.PerceivedType := '';
    try
      if Reg.OpenKey('\' + R.Extension, False) = True then
      begin
        R.ExtensionKey := Reg.ReadString('');
        R.ContentType := Reg.ReadString('Content Type');
        R.PerceivedType := Reg.ReadString('PerceivedType');
        if (FPerceivedSystem = False) and (R.PerceivedType <> '') then
          FPerceivedSystem := True; // gqO[vgVXełB
      end
      else
        Break;
    finally
      Reg.CloseKey;
    end;
    if R.ExtensionKey <> '' then
    begin
      try
        if Reg.OpenKey('\' + R.ExtensionKey, False) = True then
          R.ExtensionName := Reg.ReadString('');
      finally
        Reg.CloseKey;
      end;
      try
        if Reg.OpenKey('\' + R.ExtensionKey + '\DefaultIcon', False) = True then
          R.DefaultIcon := Reg.ReadString('');
      finally
        Reg.CloseKey;
      end;
      try
        if Reg.OpenKey('\' + R.ExtensionKey + '\shell\open\command', False) = True then
          R.Command := Reg.ReadString('');
      finally
        Reg.CloseKey;
      end;

      k := KeyNames.IndexOf(R.ExtensionKey);
      if k <> -1 then
        KeyNames.Delete(k);
    end;
    Add(R);
    Inc(i);
  end;

  if s <> -1 then
  begin
    for i := s to KeyNames.Count - 1 do
    begin
      R.Extension := '';
      R.Command := '';
      R.DefaultIcon := '';
      R.ExtensionKey := KeyNames[i];
      R.ExtensionName := '';
      R.ContentType := '';
      R.PerceivedType := '';
      try
        if Reg.OpenKey('\' + R.ExtensionKey, False) = True then
          R.ExtensionName := Reg.ReadString('')
        else
          Continue;
      finally
        Reg.CloseKey;
      end;
      try
        if Reg.OpenKey('\' + R.ExtensionKey + '\DefaultIcon', False) = True then
          R.DefaultIcon := Reg.ReadString('')
      finally
        Reg.CloseKey;
      end;
      try
        if Reg.OpenKey('\' + R.ExtensionKey + '\shell\open\command', False) = True then
          R.Command := Reg.ReadString('')
      finally
        Reg.CloseKey;
      end;
      Add(R);
    end;
  end;

  KeyNames.Free;
  Reg.Free;

  Pack; // Items z񂩂炷ׂĂ Nil ڂ폜B
  Capacity := Count; // Pack ɂč폜ꂽgp̃GgB
  SortRec; // ݂̃\[gŃ\[gB
end;

function TExtensionRecs.GetIcon(Index: Integer): TIcon;
var
  i, j: Integer;
  IconName: String;
begin
  FIcon.ReleaseHandle;
  IconName := IconNames[Index];
  IconName := TakeOff('"', IconName); // " 菜

  if AnsiPos(',', IconName) > 0 then
  begin
    i := AnsiPos(',', IconName);
    j := StrToInt(Copy(IconName, i + 1, Length(IconName) - i));
    FIcon.Handle := ExtractIcon(HInstance,
     PChar(Copy(IconName, 1, i - 1)), j);
  end
  else
    FIcon.Handle := ExtractIcon(HInstance, PChar(IconName), 0);

  if (FIcon.Empty = True) and (IconName <> '%1') then
    FIcon.Handle := ExtractIcon(HInstance, PChar('shell32.dll'), 0);

  Result := FIcon;
end;

function TExtensionRecs.GetIconName(Index: Integer): String;
var
  i: Integer;
begin
  Result := Recs[Index].DefaultIcon;
  if Result <> '' then // ACRw肳ĂB
    Exit;

  if Recs[Index].PerceivedType <> '' then // PerceivedType ̂̒TB
  begin
    for i := 0 to Count -1 do
    begin
      if (Recs[i].PerceivedType = Recs[Index].PerceivedType) then
      begin
        Result := Recs[i].DefaultIcon;
        if Result <> '' then // ACRB
          Exit;
      end;
    end;
  end;

  if Recs[Index].ContentType <> '' then // ContentType ̂̒TB
  begin
    for i := 0 to Count -1 do
    begin
      if (Recs[i].ContentType = Recs[Index].ContentType) then
      begin
        Result := Recs[i].DefaultIcon;
        if Result <> '' then // ACRB
          Exit;
      end;
    end;
  end;
end;

function TExtensionRecs.GetKeyCount: Integer;
begin
  Find('.', idExtension, Result);
end;

function TExtensionRecs.GetRec(Index: Integer): TExtensionRec;
begin
  Result := TExtensionRec(Items[Index]^);
end;

{ XgōŏɌ S ̃CfbNXԍԂ֐ }
function TExtensionRecs.IndexOf(const S: String; idType: TidType): Integer;
begin
  Result := -1; // S Ȃꍇ
  if Count = 0 then
    Exit;

  if idType = FSortType then // T[`ƃ\[gvꍇ
  begin
    if Find(S, idType, Result) = False then
      Result := -1;
  end
  else
    Result := Search(0, S, idType);
end;

procedure TExtensionRecs.Insert(Index: Integer; const Rec: TExtensionRec);
var
  Tmp: PExtensionRec;
begin
  New(Tmp);
  Tmp^ := Rec;
  inherited Insert(Index, Tmp);
  FSorted := False;
end;

procedure TExtensionRecs.Move(CurIndex, NewIndex: Integer);
begin
  inherited Move(CurIndex, NewIndex);
  FSorted := False;
end;

function TExtensionRecs.Remove(const Extension: String): Integer;
begin
  Result := IndexOf(Extension, idExtension);
  if Result <> -1 then
    Delete(Result);
end;

procedure TExtensionRecs.PutIconName(Index: Integer; const Value: String);
var
  Rec: TExtensionRec;
begin
  Rec := Recs[Index];
  Rec.DefaultIcon := Value;
  Recs[Index] := Rec;
  FSorted := False;
end;

procedure TExtensionRecs.PutRec(Index: Integer; const Rec: TExtensionRec);
begin
  TExtensionRec(Items[Index]^) := Rec;
  FSorted := False;
end;

procedure TExtensionRecs.Refresh;
begin
  FPerceivedSystem := False;
  GetExtensions;
end;

{ Xg Index Ԗڂ擪܂łōŏɌ S ̃CfbNX }
{ ԍԂ֐ }
function TExtensionRecs.RSearch(Index: Integer; const S: String; idType: TidType): Integer;
var
  i: Integer;
  compare: Integer;
begin
  Result := -1; // S Ȃꍇ
  if (Count = 0) or (Index < 0) or (Index >= Count) then
    Exit;

  compare := -1;
  for i := Index downto 0 do
  begin
    case idType of
      idExtension:     compare := AnsiCompareText(Recs[i].Extension, S);
      idCommand:       compare := AnsiCompareText(Recs[i].Command, S);
      idDefaultIcon:   compare := AnsiCompareText(Recs[i].DefaultIcon, S);
      idExtensionKey:  compare := AnsiCompareText(Recs[i].ExtensionKey, S);
      idExtensionName: compare := AnsiCompareText(Recs[i].ExtensionName, S);
      idContentType:   compare := AnsiCompareText(Recs[i].ContentType, S);
      idPerceivedType: compare := AnsiCompareText(Recs[i].PerceivedType, S);
    else
      Break;
    end;
    if compare = 0 then
    begin
      Result := i;
      Break;
    end;
  end;
end;

{ Xg Index Ԗڈȍ~AŏɌ S ̃CfbNXԍԂ֐ }
function TExtensionRecs.Search(Index: Integer; const S: String; idType: TidType): Integer;
var
  i: Integer;
  compare: Integer;
begin
  Result := -1; // S Ȃꍇ
  if (Count = 0) or (Index < 0) or (Index >= Count) then
    Exit;

  compare := -1;
  for i := Index to Count - 1 do
  begin
    case idType of
      idExtension:     compare := AnsiCompareText(Recs[i].Extension, S);
      idCommand:       compare := AnsiCompareText(Recs[i].Command, S);
      idDefaultIcon:   compare := AnsiCompareText(Recs[i].DefaultIcon, S);
      idExtensionKey:  compare := AnsiCompareText(Recs[i].ExtensionKey, S);
      idExtensionName: compare := AnsiCompareText(Recs[i].ExtensionName, S);
      idContentType:   compare := AnsiCompareText(Recs[i].ContentType, S);
      idPerceivedType: compare := AnsiCompareText(Recs[i].PerceivedType, S);
    else
      Break;
    end;
    if compare = 0 then
    begin
      Result := i;
      Break;
    end;
  end;
end;

procedure TExtensionRecs.SetSorted(Value: Boolean);
begin
  if FSorted <> Value then
  begin
    if Value = True then
      SortRec;
    FSorted := Value;
  end;
end;

procedure TExtensionRecs.SetSortType(Value: TidType);
begin
  if (FSortType <> Value) and (Value in [idExtension, idCommand, idDefaultIcon,
   idExtensionKey, idExtensionName, idContentType, idPerceivedType]) then
  begin
    if (Value = idPerceivedType) and (FPerceivedSystem = False) then
      Exit;
    FSortType := Value;
    SortRec
  end;
end;

function CompareExtension(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.Extension, rec2.Extension);
  if Result = 0 then
    Result := AnsiCompareText(rec1.ExtensionKey, rec2.ExtensionKey);
end;

function CompareCommand(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.Command, rec2.Command);
  if Result = 0 then
    Result := AnsiCompareText(rec1.Extension, rec2.Extension);
end;

function CompareDefaultIcon(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.DefaultIcon, rec2.DefaultIcon);
  if Result = 0 then
    Result := AnsiCompareText(rec1.Extension, rec2.Extension);
end;

function CompareExtensionKey(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.ExtensionKey, rec2.ExtensionKey);
  if Result = 0 then
    Result := AnsiCompareText(rec1.Extension, rec2.Extension);
end;

function CompareExtensionName(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.ExtensionName, rec2.ExtensionName);
  if Result = 0 then
    Result := AnsiCompareText(rec1.Extension, rec2.Extension);
end;

function CompareContentType(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.ContentType, rec2.ContentType);
  if Result = 0 then
    Result := AnsiCompareText(rec1.Extension, rec2.Extension);
end;

function ComparePerceivedType(Item1, Item2: Pointer): Integer;
var
  rec1, rec2: TExtensionRec;
begin
  rec1 := TExtensionRec(Item1^);
  rec2 := TExtensionRec(Item2^);

  Result := AnsiCompareText(rec1.PerceivedType, rec2.PerceivedType);
  if Result = 0 then
    Result := AnsiCompareText(rec1.Extension, rec2.Extension);
end;

procedure TExtensionRecs.SortRec;
begin
  case FSortType of
    idExtension:     inherited Sort(CompareExtension);
    idCommand:       inherited Sort(CompareCommand);
    idDefaultIcon:   inherited Sort(CompareDefaultIcon);
    idExtensionKey:  inherited Sort(CompareExtensionKey);
    idExtensionName: inherited Sort(CompareExtensionName);
    idContentType:   inherited Sort(CompareContentType);
    idPerceivedType: inherited Sort(ComparePerceivedType);
  end;
  FSorted := True;
end;

end.


